//*****************************************************************************
//* Copyright (c) 2003-2004 Miday Workshop All rights reserved.
//*
//* File: Pref.c
//*****************************************************************************

#include <PalmOS.h>
#include <SonyCLIE.h>
#include "MakeDef.h"
#include "MakeRsc.h"
#include "MakeMain.h"

//--------------------------------------------------------
//@CxgnhO
//  Event handling.
//--------------------------------------------------------
Boolean PreferencesHandleEvent (EventType * event) {
	Boolean handled = false;
	//Version 3.2 Add Start
	short ia;
	//Version 3.2 Add End

	frm = FrmGetFormPtr (Preferences);

	if (event->eType == ctlSelectEvent) {
		switch (event->data.ctlSelect.controlID) {
		case PreferencesOKButton:
			Opt3.data_ver        = 3 - CtlGetValue(GetObjectPtr(PreferencesV2CheckBox));
			Opt3.hol_count_flag  = CtlGetValue(GetObjectPtr(PreferencesHolCheckBox));
			Opt3.beam_opt        = CtlGetValue(GetObjectPtr(PreferencesBeamCheckBox));
			Opt3p.data_ver       = Opt3.data_ver;
			Opt3p.hol_count_flag = Opt3.hol_count_flag;
	//Version 3.2 Add Start
			if ( Opt3p.hol_count_flag == 0 ) {
				for (ia=0; ia<Max_Color_no; ia++) {
					Color_def[ia].hol_flag = 1;
				}
			}
	//Version 3.2 Add End
			Opt3p.beam_opt       = Opt3.beam_opt;
			PrefSetAppPreferences (Df_CreaID, 2, Md_Version, &Opt3p, sizeof(OPTIONS3), true);
			FrmGotoForm (MainWin);
			handled = true;
			break;
		case PreferencesCancelButton:
			FrmGotoForm (MainWin);
			handled = true;
			break;
		}

	} else if (event->eType == menuEvent) {
		switch (event->data.menu.itemID) {
		case AboutAboutCmd:
			FrmPopupForm(AboutDialog);
			break;
		}

	} else if (event->eType == frmOpenEvent) {
		CtlSetValue(GetObjectPtr(PreferencesV2CheckBox),3-Opt3.data_ver);
		CtlSetValue(GetObjectPtr(PreferencesHolCheckBox),Opt3.hol_count_flag);
		CtlSetValue(GetObjectPtr(PreferencesBeamCheckBox),Opt3.beam_opt);
		FrmDrawForm (frm);
		handled = true;
	}

	return (handled);
}
